SystemOrganization addCategory: #'JQWidgetBox-JQTools-Tabs-Dev-Example'!
SystemOrganization addCategory: #'JQWidgetBox-JQTools-Tabs-Dev-Tests'!

JQWidgetBoxWidgetTest subclass: #JQWidgetBoxJQTabsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-JQTools-Tabs-Dev-Tests'!

!JQWidgetBoxJQTabsTest methodsFor: 'testing' stamp: 'NickAger 2/10/2010 08:40'!
testActions
	self
		assert: ((self jQuery: 'id') jqToolsTabs panesSelector: (self jQuery: #idPanes))
		equals: self function, '("id").tabs($("#idPanes"))'.! !

JQWidgetExample subclass: #JQWidgetBoxJQToolsTabsExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-JQTools-Tabs-Dev-Example'!

!JQWidgetBoxJQToolsTabsExample classSide methodsFor: 'as yet unclassified' stamp: 'NickAger 2/9/2010 13:29'!
description
	^ 'JQuery Tools tabs'! !

!JQWidgetBoxJQToolsTabsExample classSide methodsFor: 'as yet unclassified' stamp: 'NickAger 2/9/2010 13:31'!
shortName
 	^ 'jqtoolstabs'! !

!JQWidgetBoxJQToolsTabsExample methodsFor: 'rendering' stamp: 'NickAger 2/10/2010 08:34'!
renderContentOn: html
	html heading level: 3; with: 'jQuery Tool tabs'.
	html paragraph with: [
		html text: 'For original (extensive) documentation see: '.
		html anchor url: 'http://flowplayer.org/tools/tabs.html'; with: 'http://flowplayer.org/tools/tabs.html'
	].
	html paragraph with: [
		html emphasis: 'Question: '. html text: 'Why bother integrating another tabbed control into Seaside when the core implementation already provides one? '.
		html break.
		html emphasis: 'Answer: '. html text: 'My motiviation stemmed from frustration with the integrated jQuery UI tab control which didn''t provide sufficient control over the final look for the tab. Specifically I wanted to use a background bitmap for styling and couldn''t find a way to achieve that with the jQuery UI control.'
		].

	"the tabs"
	html unorderedList
		class:'tabs'; 
		script: (html jQuery this jqToolsTabs panesSelector: (html jQuery: 'div.panes > div')) ;
		with: [	
			html listItem: [html anchor url: '#'; with: 'Tab 1'].
			html listItem: [html anchor url: '#'; with: 'Tab 2'].
			html listItem: [html anchor url: '#'; with: 'Tab 3'].
		].

	"tab panes"
	html div class: 'panes'; with: [
		html div: 'First tab content. Tab contents are called "panes"'.
		html div: 'second tab content. Tab contents are called "panes"'.
		html div: 'third tab content. Tab contents are called "panes"'.
	]! !

!JQWidgetBoxJQToolsTabsExample methodsFor: 'rendering' stamp: 'NickAger 2/9/2010 13:13'!
tabCss
	^
'/* tab pane styling */
div.panes div {
	display:none;		
	padding:15px 10px;
	border:1px solid #999;
	border-top:0;
	height:100px;
	font-size:14px;
	background-color:#fff;
}	
'! !

!JQWidgetBoxJQToolsTabsExample methodsFor: 'updating' stamp: 'NickAger 2/10/2010 08:13'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	"unfortunately jQuery Tool tabs and jQuery UI tabs, use the same javascript name 'tabs' and 
	so (i believe) shouldn't coexist on the same page. Remove any reference to a url to jqueryui"
	anHtmlRoot headElements removeAllSuchThat: [:each | | url |
		url := each attributes at: 'src' ifAbsent: [ nil ].
		url ifNotNil: [
			url greaseString asLowercase includesSubString: 'jqueryui'
			] ifNil: [ false ]
		].

	anHtmlRoot javascript url: self library / #toolstabs104Js.
	
	anHtmlRoot stylesheet url: 'http://static.flowplayer.org/tools/css/tabs.css'. "styling for tabs"
	anHtmlRoot addStyle: self tabCss. "styling for panes"! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-jqtools-tabs-dev' stamp: ''!
toolstabs104Js
	^ '/**
 * tools.tabs 1.0.4 - Tabs done right.
 * 
 * Copyright (c) 2009 Tero Piirainen
 * http://flowplayer.org/tools/tabs.html
 *
 * Dual licensed under MIT and GPL 2+ licenses
 * http://www.opensource.org/licenses
 *
 * Launch  : November 2008
 * Date: ${date}
 * Revision: ${revision} 
 */  
(function($) {
		
	// static constructs
	$.tools = $.tools || {};
	
	$.tools.tabs = {
		version: ''1.0.4'',
		
		conf: {
			tabs: ''a'',
			current: ''current'',
			onBeforeClick: null,
			onClick: null, 
			effect: ''default'',
			initialIndex: 0,			
			event: ''click'',
			api:false,
			rotate: false
		},
		
		addEffect: function(name, fn) {
			effects[name] = fn;
		}
	};		
	
	
	var effects = {
		
		// simple "toggle" effect
		''default'': function(i, done) { 
			this.getPanes().hide().eq(i).show();
			done.call();
		}, 
		
		/*
			configuration:
				- fadeOutSpeed (positive value does "crossfading")
				- fadeInSpeed
		*/
		fade: function(i, done) {
			var conf = this.getConf(), 
				 speed = conf.fadeOutSpeed,
				 panes = this.getPanes();
			
			if (speed) {
				panes.fadeOut(speed);	
			} else {
				panes.hide();	
			}

			panes.eq(i).fadeIn(conf.fadeInSpeed, done);	
		},
		
		// for basic accordions
		slide: function(i, done) {			
			this.getPanes().slideUp(200);
			this.getPanes().eq(i).slideDown(400, done);			 
		}, 

		// simple AJAX effect
		ajax: function(i, done)  {			
			this.getPanes().eq(0).load(this.getTabs().eq(i).attr("href"), done);	
		}
		
	};   	
	
	var w;
	
	// this is how you add effects
	$.tools.tabs.addEffect("horizontal", function(i, done) {
	
		// store original width of a pane into memory
		if (!!w) { w = this.getPanes().eq(0).width(); }
		
		// set current pane''s width to zero
		this.getCurrentPane().animate({width: 0}, function() { $(this).hide(); });
		
		// grow opened pane to it''s original width
		this.getPanes().eq(i).animate({width: w}, function() { 
			$(this).show();
			done.call();
		});
		
	});	
	 

	function Tabs(tabs, panes, conf) { 
		
		var self = this, $self = $(this), current;

		// bind all callbacks from configuration
		$.each(conf, function(name, fn) {
			if ($.isFunction(fn)) { $self.bind(name, fn); }
		});
		
		
		// public methods
		$.extend(this, {				
			click: function(i, e) {
				
				var pane = self.getCurrentPane();				
				var tab = tabs.eq(i);												 
				
				if (typeof i == ''string'' && i.replace("#", "")) {
					tab = tabs.filter("[href*=" + i.replace("#", "") + "]");
					i = Math.max(tabs.index(tab), 0);
				}
								
				if (conf.rotate) {
					var last = tabs.length -1; 
					if (i < 0) { return self.click(last, e); }
					if (i > last) { return self.click(0, e); }						
				}
				
				if (!!tab.length) { 
					if (current >= 0) { return self; }
					i = conf.initialIndex;
					tab = tabs.eq(i);
				}				
				
				// current tab is being clicked
				if (i === current) { return self; }
				
				// possibility to cancel click action				
				e = e || $.Event();
				e.type = "onBeforeClick";
				$self.trigger(e, [i]);				
				if (e.isDefaultPrevented()) { return; }
				
				// call the effect
				effects[conf.effect].call(self, i, function() {

					// onClick callback
					e.type = "onClick";
					$self.trigger(e, [i]);					
				});			
				
				// onStart
				e.type = "onStart";
				$self.trigger(e, [i]);				
				if (e.isDefaultPrevented()) { return; } 
				
				// default behaviour
				current = i;
				tabs.removeClass(conf.current);	
				tab.addClass(conf.current);				
				
				return self;
			},
			
			getConf: function() {
				return conf;	
			},

			getTabs: function() {
				return tabs;	
			},
			
			getPanes: function() {
				return panes;	
			},
			
			getCurrentPane: function() {
				return panes.eq(current);	
			},
			
			getCurrentTab: function() {
				return tabs.eq(current);	
			},
			
			getIndex: function() {
				return current;	
			}, 
			
			next: function() {
				return self.click(current + 1);
			},
			
			prev: function() {
				return self.click(current - 1);	
			}, 
			
			bind: function(name, fn) {
				$self.bind(name, fn);
				return self;	
			},	
			
			onBeforeClick: function(fn) {
				return this.bind("onBeforeClick", fn);
			},
			
			onClick: function(fn) {
				return this.bind("onClick", fn);
			},
			
			unbind: function(name) {
				$self.unbind(name);
				return self;	
			}			
		
		});
		
		
		// setup click actions for each tab
		tabs.each(function(i) { 
			$(this).bind(conf.event, function(e) {
				self.click(i, e);
				return false;
			});			
		});

		// if no pane is visible --> click on the first tab
		if (location.hash) {
			self.click(location.hash);
		} else {
			if (conf.initialIndex === 0 || conf.initialIndex > 0) {
				self.click(conf.initialIndex);
			}
		}		
		
		// cross tab anchor link
		panes.find("a[href^=#]").click(function(e) {
			self.click($(this).attr("href"), e);		
		}); 
	}
	
	
	// jQuery plugin implementation
	$.fn.tabs = function(query, conf) {
		
		// return existing instance
		var el = this.eq(typeof conf == ''number'' ? conf : 0).data("tabs");
		if (el) { return el; }

		if ($.isFunction(conf)) {
			conf = {onBeforeClick: conf};
		}
		
		// setup options
		var globals = $.extend({}, $.tools.tabs.conf), len = this.length;
		conf = $.extend(globals, conf);		

		
		// install tabs for each items in jQuery		
		this.each(function(i) {				
			var root = $(this); 
			
			// find tabs
			var els = root.find(conf.tabs);
			
			if (!!els.length) {
				els = root.children();	
			}
			
			// find panes
			var panes = query.jquery ? query : root.children(query);
			
			if (!!panes.length) {
				panes = len == 1 ? $(query) : root.parent().find(query);
			}			
			
			el = new Tabs(els, panes, conf);
			root.data("tabs", el);
			
		});		
		
		return conf.api ? el: this;		
	};		
		
}) (jQuery); 


'! !
